#line 4 "src/test/grad/test_grad_beta.birch"
int birch::test_grad_beta(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_beta.birch"
  libbirch_function_("test_grad_beta", "src/test/grad/test_grad_beta.birch", 4);
  #line 4 "src/test/grad/test_grad_beta.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_beta.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_beta.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_beta.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_beta.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_beta.birch"
  };
  #line 4 "src/test/grad/test_grad_beta.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_beta.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_beta.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_beta.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_beta.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_beta.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_beta.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_beta.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_beta.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_beta.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_beta.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_beta.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_beta.birch"
      default:
        #line 4 "src/test/grad/test_grad_beta.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_beta.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_beta.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_beta.birch"
  auto _u0945 = birch::simulate_uniform(1.0, 10.0, handler_);
  #line 6 "src/test/grad/test_grad_beta.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_beta.birch"
  auto _u0946 = birch::simulate_uniform(1.0, 10.0, handler_);
  #line 7 "src/test/grad/test_grad_beta.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_beta.birch"
  auto q = birch::Beta(_u0945, _u0946, handler_);
  #line 8 "src/test/grad/test_grad_beta.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_beta.birch"
  birch::test_grad(q, N, handler_);
  #line 4 "src/test/grad/test_grad_beta.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_beta.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_exponential.birch"
int birch::test_grad_exponential(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_exponential.birch"
  libbirch_function_("test_grad_exponential", "src/test/grad/test_grad_exponential.birch", 4);
  #line 4 "src/test/grad/test_grad_exponential.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_exponential.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_exponential.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_exponential.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_exponential.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_exponential.birch"
  };
  #line 4 "src/test/grad/test_grad_exponential.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_exponential.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_exponential.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_exponential.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_exponential.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_exponential.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_exponential.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_exponential.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_exponential.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_exponential.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_exponential.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_exponential.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_exponential.birch"
      default:
        #line 4 "src/test/grad/test_grad_exponential.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_exponential.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_exponential.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_exponential.birch"
  auto _u0955 = birch::simulate_uniform(1.0, 10.0, handler_);
  #line 6 "src/test/grad/test_grad_exponential.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_exponential.birch"
  auto q = birch::Exponential(_u0955, handler_);
  #line 7 "src/test/grad/test_grad_exponential.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_exponential.birch"
  birch::test_grad(q, N, handler_);
  #line 4 "src/test/grad/test_grad_exponential.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_exponential.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_gamma.birch"
int birch::test_grad_gamma(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_gamma.birch"
  libbirch_function_("test_grad_gamma", "src/test/grad/test_grad_gamma.birch", 4);
  #line 4 "src/test/grad/test_grad_gamma.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_gamma.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_gamma.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_gamma.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_gamma.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_gamma.birch"
  };
  #line 4 "src/test/grad/test_grad_gamma.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_gamma.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_gamma.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_gamma.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_gamma.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_gamma.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_gamma.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_gamma.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_gamma.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_gamma.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_gamma.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_gamma.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_gamma.birch"
      default:
        #line 4 "src/test/grad/test_grad_gamma.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_gamma.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_gamma.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_gamma.birch"
  auto k = birch::simulate_uniform(1.0, 10.0, handler_);
  #line 6 "src/test/grad/test_grad_gamma.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_gamma.birch"
  auto _u0952 = birch::simulate_uniform(0.0, 10.0, handler_);
  #line 7 "src/test/grad/test_grad_gamma.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_gamma.birch"
  auto q = birch::Gamma(k, _u0952, handler_);
  #line 8 "src/test/grad/test_grad_gamma.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_gamma.birch"
  birch::test_grad(q, N, handler_);
  #line 4 "src/test/grad/test_grad_gamma.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_gamma.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_gamma_exponential.birch"
int birch::test_grad_gamma_exponential(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
  libbirch_function_("test_grad_gamma_exponential", "src/test/grad/test_grad_gamma_exponential.birch", 4);
  #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
  };
  #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
      default:
        #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_gamma_exponential.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_gamma_exponential.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestGammaExponential>> m;
  #line 6 "src/test/grad/test_grad_gamma_exponential.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_gamma_exponential.birch"
  m->initialize(handler_);
  #line 7 "src/test/grad/test_grad_gamma_exponential.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_gamma_exponential.birch"
  m->simulate(handler_);
  #line 8 "src/test/grad/test_grad_gamma_exponential.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_gamma_exponential.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_gamma_exponential.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_gaussian.birch"
int birch::test_grad_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_gaussian.birch"
  libbirch_function_("test_grad_gaussian", "src/test/grad/test_grad_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_gaussian.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_gaussian.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_gaussian.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_gaussian.birch"
  auto _u0956 = birch::simulate_uniform(-10.0, 10.0, handler_);
  #line 6 "src/test/grad/test_grad_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_gaussian.birch"
  auto _u09632 = birch::simulate_uniform(0.0, 10.0, handler_);
  #line 7 "src/test/grad/test_grad_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_gaussian.birch"
  auto q = birch::Gaussian(_u0956, _u09632, handler_);
  #line 8 "src/test/grad/test_grad_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_gaussian.birch"
  birch::test_grad(q, N, handler_);
  #line 4 "src/test/grad/test_grad_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_inverse_gamma.birch"
int birch::test_grad_inverse_gamma(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
  libbirch_function_("test_grad_inverse_gamma", "src/test/grad/test_grad_inverse_gamma.birch", 4);
  #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
  };
  #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
      default:
        #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_inverse_gamma.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_inverse_gamma.birch"
  auto _u0945 = birch::simulate_uniform(2.0, 10.0, handler_);
  #line 6 "src/test/grad/test_grad_inverse_gamma.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_inverse_gamma.birch"
  auto _u0946 = birch::simulate_uniform(0.1, 10.0, handler_);
  #line 7 "src/test/grad/test_grad_inverse_gamma.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_inverse_gamma.birch"
  auto q = birch::InverseGamma(_u0945, _u0946, handler_);
  #line 8 "src/test/grad/test_grad_inverse_gamma.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_inverse_gamma.birch"
  birch::test_grad(q, N, handler_);
  #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_inverse_gamma.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
int birch::test_grad_inverse_gamma_gamma(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  libbirch_function_("test_grad_inverse_gamma_gamma", "src/test/grad/test_grad_inverse_gamma_gamma.birch", 4);
  #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  };
  #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
      default:
        #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestInverseGammaGamma>> m;
  #line 6 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  m->initialize(handler_);
  #line 7 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  m->simulate(handler_);
  #line 8 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_inverse_gamma_gamma.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
int birch::test_grad_linear_gaussian_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  libbirch_function_("test_grad_linear_gaussian_gaussian", "src/test/grad/test_grad_linear_gaussian_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestLinearGaussianGaussian>> m;
  #line 6 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  m->initialize(handler_);
  #line 7 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  m->simulate(handler_);
  #line 8 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_linear_gaussian_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
int birch::test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_function_("test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian", "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
    switch (c_) {
      #line 5 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
      case NFLAG_:
        #line 5 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 5 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 6 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestLinearMatrixNormalInverseWishartMatrixGaussian>> m;
  #line 7 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  m->initialize(handler_);
  #line 8 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  m->simulate(handler_);
  #line 9 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_line_(9);
  #line 9 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
int birch::test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  libbirch_function_("test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian", "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
    switch (c_) {
      #line 5 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
      case NFLAG_:
        #line 5 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 5 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 6 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestLinearMatrixNormalInverseWishartMultivariateGaussian>> m;
  #line 7 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  m->initialize(handler_);
  #line 8 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  m->simulate(handler_);
  #line 9 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  libbirch_line_(9);
  #line 9 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_linear_matrix_normal_inverse_wishart_multivariate_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
int birch::test_grad_linear_multivariate_gaussian_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  libbirch_function_("test_grad_linear_multivariate_gaussian_gaussian", "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestLinearMultivariateGaussianGaussian>> m;
  #line 6 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  m->initialize(handler_);
  #line 7 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  m->simulate(handler_);
  #line 8 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
int birch::test_grad_linear_multivariate_gaussian_multivariate_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_function_("test_grad_linear_multivariate_gaussian_multivariate_gaussian", "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
    switch (c_) {
      #line 5 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
      case NFLAG_:
        #line 5 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 5 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 6 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestLinearMultivariateGaussianMultivariateGaussian>> m;
  #line 7 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  m->initialize(handler_);
  #line 8 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  m->simulate(handler_);
  #line 9 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_line_(9);
  #line 9 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_linear_multivariate_gaussian_multivariate_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
int birch::test_grad_linear_multivariate_normal_inverse_gamma_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  libbirch_function_("test_grad_linear_multivariate_normal_inverse_gamma_gaussian", "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
    switch (c_) {
      #line 5 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
      case NFLAG_:
        #line 5 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 5 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 6 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestLinearMultivariateNormalInverseGammaGaussian>> m;
  #line 7 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  m->initialize(handler_);
  #line 8 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  m->simulate(handler_);
  #line 9 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(9);
  #line 9 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
int birch::test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_function_("test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian", "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
    switch (c_) {
      #line 5 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
      case NFLAG_:
        #line 5 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 5 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 6 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestLinearMultivariateNormalInverseGammaMultivariateGaussian>> m;
  #line 7 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  m->initialize(handler_);
  #line 8 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  m->simulate(handler_);
  #line 9 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_line_(9);
  #line 9 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_linear_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
int birch::test_grad_linear_normal_inverse_gamma_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  libbirch_function_("test_grad_linear_normal_inverse_gamma_gaussian", "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestLinearNormalInverseGammaGaussian>> m;
  #line 6 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  m->initialize(handler_);
  #line 7 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  m->simulate(handler_);
  #line 8 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_linear_normal_inverse_gamma_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
int birch::test_grad_matrix_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_function_("test_grad_matrix_gaussian", "src/test/grad/test_grad_matrix_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  birch::type::Integer R = birch::type::Integer(4);
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  birch::type::Integer C = birch::type::Integer(3);
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    RFLAG_,
    CFLAG_,
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
    {"R", required_argument, 0, RFLAG_ },
    #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
    {"C", required_argument, 0, CFLAG_ },
    #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
      case RFLAG_:
        #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
        R = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
      case CFLAG_:
        #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
        C = birch::Integer(std::string(::optarg));
        break;
      #line 5 "src/test/grad/test_grad_matrix_gaussian.birch"
      case NFLAG_:
        #line 5 "src/test/grad/test_grad_matrix_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 5 "src/test/grad/test_grad_matrix_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 6 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch::DefaultArray<birch::type::Real,2> M(libbirch::make_shape(R, C));
  #line 7 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch::DefaultArray<birch::type::Real,2> U(libbirch::make_shape(R, R));
  #line 8 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch::DefaultArray<birch::type::Real,2> V(libbirch::make_shape(C, C));
  #line 10 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_line_(10);
  #line 10 "src/test/grad/test_grad_matrix_gaussian.birch"
  for (auto i = birch::type::Integer(1); i <= R; ++i) {
    #line 11 "src/test/grad/test_grad_matrix_gaussian.birch"
    libbirch_line_(11);
    #line 11 "src/test/grad/test_grad_matrix_gaussian.birch"
    for (auto j = birch::type::Integer(1); j <= C; ++j) {
      #line 12 "src/test/grad/test_grad_matrix_gaussian.birch"
      libbirch_line_(12);
      #line 12 "src/test/grad/test_grad_matrix_gaussian.birch"
      M.set(libbirch::make_slice(i - 1, j - 1), birch::simulate_uniform(-10.0, 10.0, handler_));
    }
  }
  #line 15 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_line_(15);
  #line 15 "src/test/grad/test_grad_matrix_gaussian.birch"
  for (auto i = birch::type::Integer(1); i <= R; ++i) {
    #line 16 "src/test/grad/test_grad_matrix_gaussian.birch"
    libbirch_line_(16);
    #line 16 "src/test/grad/test_grad_matrix_gaussian.birch"
    for (auto j = birch::type::Integer(1); j <= R; ++j) {
      #line 17 "src/test/grad/test_grad_matrix_gaussian.birch"
      libbirch_line_(17);
      #line 17 "src/test/grad/test_grad_matrix_gaussian.birch"
      U.set(libbirch::make_slice(i - 1, j - 1), birch::simulate_uniform(-2.0, 2.0, handler_));
    }
  }
  #line 20 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_line_(20);
  #line 20 "src/test/grad/test_grad_matrix_gaussian.birch"
  for (auto i = birch::type::Integer(1); i <= C; ++i) {
    #line 21 "src/test/grad/test_grad_matrix_gaussian.birch"
    libbirch_line_(21);
    #line 21 "src/test/grad/test_grad_matrix_gaussian.birch"
    for (auto j = birch::type::Integer(1); j <= C; ++j) {
      #line 22 "src/test/grad/test_grad_matrix_gaussian.birch"
      libbirch_line_(22);
      #line 22 "src/test/grad/test_grad_matrix_gaussian.birch"
      V.set(libbirch::make_slice(i - 1, j - 1), birch::simulate_uniform(-2.0, 2.0, handler_));
    }
  }
  #line 25 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_line_(25);
  #line 25 "src/test/grad/test_grad_matrix_gaussian.birch"
  U = U * birch::transpose(U, handler_);
  #line 26 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_line_(26);
  #line 26 "src/test/grad/test_grad_matrix_gaussian.birch"
  V = V * birch::transpose(V, handler_);
  #line 28 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_line_(28);
  #line 28 "src/test/grad/test_grad_matrix_gaussian.birch"
  auto _u0960 = birch::Gaussian(M, U, V, handler_);
  #line 29 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_line_(29);
  #line 29 "src/test/grad/test_grad_matrix_gaussian.birch"
  birch::test_grad(_u0960, N, handler_);
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_matrix_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
int birch::test_grad_matrix_normal_inverse_wishart(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_function_("test_grad_matrix_normal_inverse_wishart", "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch", 4);
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  birch::type::Integer R = birch::type::Integer(3);
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  birch::type::Integer C = birch::type::Integer(2);
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    RFLAG_,
    CFLAG_,
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    {"R", required_argument, 0, RFLAG_ },
    #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    {"C", required_argument, 0, CFLAG_ },
    #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  };
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      case RFLAG_:
        #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
        R = birch::Integer(std::string(::optarg));
        break;
      #line 5 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      case CFLAG_:
        #line 5 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 5 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
        C = birch::Integer(std::string(::optarg));
        break;
      #line 5 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      case NFLAG_:
        #line 5 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 5 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      default:
        #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 6 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch::DefaultArray<birch::type::Real,2> M(libbirch::make_shape(R, C));
  #line 7 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch::DefaultArray<birch::type::Real,2> U(libbirch::make_shape(R, R));
  #line 8 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  birch::type::Real k;
  #line 9 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(9);
  #line 9 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch::DefaultArray<birch::type::Real,2> _u0936(libbirch::make_shape(C, C));
  #line 11 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(11);
  #line 11 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  for (auto i = birch::type::Integer(1); i <= R; ++i) {
    #line 12 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    libbirch_line_(12);
    #line 12 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    for (auto j = birch::type::Integer(1); j <= C; ++j) {
      #line 13 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      libbirch_line_(13);
      #line 13 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      M.set(libbirch::make_slice(i - 1, j - 1), birch::simulate_uniform(-10.0, 10.0, handler_));
    }
  }
  #line 16 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(16);
  #line 16 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  for (auto i = birch::type::Integer(1); i <= R; ++i) {
    #line 17 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    libbirch_line_(17);
    #line 17 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    for (auto j = birch::type::Integer(1); j <= R; ++j) {
      #line 18 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      libbirch_line_(18);
      #line 18 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      U.set(libbirch::make_slice(i - 1, j - 1), birch::simulate_uniform(-2.0, 2.0, handler_));
    }
  }
  #line 21 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(21);
  #line 21 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  k = C + 1.0 + birch::simulate_uniform(0.0, 10.0, handler_);
  #line 22 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(22);
  #line 22 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  for (auto i = birch::type::Integer(1); i <= C; ++i) {
    #line 23 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    libbirch_line_(23);
    #line 23 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
    for (auto j = birch::type::Integer(1); j <= C; ++j) {
      #line 24 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      libbirch_line_(24);
      #line 24 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
      _u0936.set(libbirch::make_slice(i - 1, j - 1), birch::simulate_uniform(-2.0, 2.0, handler_));
    }
  }
  #line 27 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(27);
  #line 27 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  U = U * birch::transpose(U, handler_);
  #line 28 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(28);
  #line 28 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  _u0936 = _u0936 * birch::transpose(_u0936, handler_);
  #line 30 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(30);
  #line 30 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::InverseWishart>> V(birch::box(birch::llt(_u0936, handler_), handler_), birch::box(k, handler_));
  #line 31 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(31);
  #line 31 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::MatrixNormalInverseWishart>> _u0960(birch::box(M, handler_), birch::box(birch::llt(U, handler_), handler_), V);
  #line 32 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(32);
  #line 32 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  birch::test_grad(_u0960, N, handler_);
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
int birch::test_grad_matrix_normal_inverse_wishart_matrix_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_function_("test_grad_matrix_normal_inverse_wishart_matrix_gaussian", "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
    switch (c_) {
      #line 5 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
      case NFLAG_:
        #line 5 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 5 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 6 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestMatrixNormalInverseWishartMatrixGaussian>> m;
  #line 7 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  m->initialize(handler_);
  #line 8 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  m->simulate(handler_);
  #line 9 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_line_(9);
  #line 9 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_matrix_normal_inverse_wishart_matrix_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
int birch::test_grad_multivariate_gaussian_multivariate_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_function_("test_grad_multivariate_gaussian_multivariate_gaussian", "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
    switch (c_) {
      #line 5 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
      case NFLAG_:
        #line 5 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 5 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 6 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestMultivariateGaussianMultivariateGaussian>> m;
  #line 7 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  m->initialize(handler_);
  #line 8 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  m->simulate(handler_);
  #line 9 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_line_(9);
  #line 9 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_multivariate_gaussian_multivariate_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
int birch::test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_function_("test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian", "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
    switch (c_) {
      #line 5 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
      case NFLAG_:
        #line 5 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 5 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 6 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestMultivariateNormalInverseGammaMultivariateGaussian>> m;
  #line 7 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  m->initialize(handler_);
  #line 8 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  m->simulate(handler_);
  #line 9 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_line_(9);
  #line 9 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_multivariate_normal_inverse_gamma_multivariate_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
int birch::test_grad_normal_inverse_gamma(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  libbirch_function_("test_grad_normal_inverse_gamma", "src/test/grad/test_grad_normal_inverse_gamma.birch", 4);
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  };
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
      default:
        #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestNormalInverseGamma>> m;
  #line 6 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  m->initialize(handler_);
  #line 7 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  m->simulate(handler_);
  #line 8 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
int birch::test_grad_normal_inverse_gamma_gaussian(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  libbirch_function_("test_grad_normal_inverse_gamma_gaussian", "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch", 4);
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  };
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
      default:
        #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestNormalInverseGammaGaussian>> m;
  #line 6 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  m->initialize(handler_);
  #line 7 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  m->simulate(handler_);
  #line 8 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_normal_inverse_gamma_gaussian.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
int birch::test_grad_scaled_gamma_exponential(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  libbirch_function_("test_grad_scaled_gamma_exponential", "src/test/grad/test_grad_scaled_gamma_exponential.birch", 4);
  #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  };
  #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
      default:
        #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  libbirch::Lazy<libbirch::Shared<birch::type::TestScaledGammaExponential>> m;
  #line 6 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  m->initialize(handler_);
  #line 7 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  m->simulate(handler_);
  #line 8 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  birch::test_grad(m->marginal(handler_), N, handler_);
  #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_scaled_gamma_exponential.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_student_t.birch"
int birch::test_grad_student_t(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_student_t.birch"
  libbirch_function_("test_grad_student_t", "src/test/grad/test_grad_student_t.birch", 4);
  #line 4 "src/test/grad/test_grad_student_t.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_student_t.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_student_t.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_student_t.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_student_t.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_student_t.birch"
  };
  #line 4 "src/test/grad/test_grad_student_t.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_student_t.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_student_t.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_student_t.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_student_t.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_student_t.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_student_t.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_student_t.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_student_t.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_student_t.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_student_t.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_student_t.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_student_t.birch"
      default:
        #line 4 "src/test/grad/test_grad_student_t.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_student_t.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_student_t.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_student_t.birch"
  auto k = birch::simulate_uniform(1.0, 10.0, handler_);
  #line 6 "src/test/grad/test_grad_student_t.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_student_t.birch"
  auto _u0956 = birch::simulate_uniform(-10.0, 10.0, handler_);
  #line 7 "src/test/grad/test_grad_student_t.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_student_t.birch"
  auto _u09632 = birch::simulate_uniform(0.0, 10.0, handler_);
  #line 8 "src/test/grad/test_grad_student_t.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_student_t.birch"
  auto q = birch::Student(k, _u0956, _u09632, handler_);
  #line 9 "src/test/grad/test_grad_student_t.birch"
  libbirch_line_(9);
  #line 9 "src/test/grad/test_grad_student_t.birch"
  birch::test_grad(q, N, handler_);
  #line 4 "src/test/grad/test_grad_student_t.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_student_t.birch"
  return 0;
}

#line 4 "src/test/grad/test_grad_weibull.birch"
int birch::test_grad_weibull(int argc_, char** argv_) {
  #line 4 "src/test/grad/test_grad_weibull.birch"
  libbirch_function_("test_grad_weibull", "src/test/grad/test_grad_weibull.birch", 4);
  #line 4 "src/test/grad/test_grad_weibull.birch"
  birch::type::Integer N = birch::type::Integer(1000);
  
  enum {
    NFLAG_,
  };
  #line 4 "src/test/grad/test_grad_weibull.birch"
  int c_, option_index_;
  #line 4 "src/test/grad/test_grad_weibull.birch"
  option long_options_[] = {
    #line 4 "src/test/grad/test_grad_weibull.birch"
    {"N", required_argument, 0, NFLAG_ },
    #line 4 "src/test/grad/test_grad_weibull.birch"
    {0, 0, 0, 0}
  #line 4 "src/test/grad/test_grad_weibull.birch"
  };
  #line 4 "src/test/grad/test_grad_weibull.birch"
  const char* short_options_ = ":";
  #line 4 "src/test/grad/test_grad_weibull.birch"
  ::opterr = 0;
  #line 4 "src/test/grad/test_grad_weibull.birch"
  c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  #line 4 "src/test/grad/test_grad_weibull.birch"
  while (c_ != -1) {
    #line 4 "src/test/grad/test_grad_weibull.birch"
    switch (c_) {
      #line 4 "src/test/grad/test_grad_weibull.birch"
      case NFLAG_:
        #line 4 "src/test/grad/test_grad_weibull.birch"
        libbirch_error_msg_(::optarg, "option --" << long_options_[::optopt].name << " requires a value.");
        #line 4 "src/test/grad/test_grad_weibull.birch"
        N = birch::Integer(std::string(::optarg));
        break;
      #line 4 "src/test/grad/test_grad_weibull.birch"
      case '?':
        #line 4 "src/test/grad/test_grad_weibull.birch"
        libbirch_error_msg_(false, "option " << argv_[::optind - 1] << " unrecognized.");
      #line 4 "src/test/grad/test_grad_weibull.birch"
      case ':':
        #line 4 "src/test/grad/test_grad_weibull.birch"
        libbirch_error_msg_(false, "option --" << long_options_[::optopt].name << " requires a value.");
      #line 4 "src/test/grad/test_grad_weibull.birch"
      default:
        #line 4 "src/test/grad/test_grad_weibull.birch"
        libbirch_error_msg_(false, std::string("unknown error parsing command-line options."));
    }
    #line 4 "src/test/grad/test_grad_weibull.birch"
    c_ = ::getopt_long_only(argc_, argv_, short_options_, long_options_, &option_index_);
  }

  libbirch::Lazy<libbirch::Shared<birch::type::PlayHandler>> handler_(true);

  #line 5 "src/test/grad/test_grad_weibull.birch"
  libbirch_line_(5);
  #line 5 "src/test/grad/test_grad_weibull.birch"
  auto k = birch::simulate_uniform(1.0, 10.0, handler_);
  #line 6 "src/test/grad/test_grad_weibull.birch"
  libbirch_line_(6);
  #line 6 "src/test/grad/test_grad_weibull.birch"
  auto _u0955 = birch::simulate_uniform(0.1, 10.0, handler_);
  #line 7 "src/test/grad/test_grad_weibull.birch"
  libbirch_line_(7);
  #line 7 "src/test/grad/test_grad_weibull.birch"
  auto q = birch::Weibull(k, _u0955, handler_);
  #line 8 "src/test/grad/test_grad_weibull.birch"
  libbirch_line_(8);
  #line 8 "src/test/grad/test_grad_weibull.birch"
  birch::test_grad(q, N, handler_);
  #line 4 "src/test/grad/test_grad_weibull.birch"
  libbirch_line_(4);
  #line 4 "src/test/grad/test_grad_weibull.birch"
  return 0;
}

